local mod = ...


-- TESTING CHEAT: Change the starting Village Center inventory
-- mod:override({
	-- Id = "DEFAULT_VILLAGE_CENTER_INVENTORY",
	-- Collection = {
        -- {Resource = "WOOD", Quantity = 100000}, 
        -- {Resource = "STONE", Quantity = 100000}, 
        -- {Resource = "PLANK", Quantity = 100000},
        -- {Resource = "TOOL", Quantity = 100000},
        -- {Resource = "GOLD", Quantity = 100000}
    -- }
-- })


-- Assets
-------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/BerryFarm.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetId("models/BerryFarm.fbx/Prefab/BerryHutPart01", "PREFAB_BERRYHUT01")
mod:registerAssetId("models/BerryFarm.fbx/Prefab/BerryBushRedPart", "PREFAB_BERRYBUSHRED_001")
mod:registerAssetId("models/BerryFarm.fbx/Prefab/BerryBushBluePart", "PREFAB_BERRYBUSHBLUE_001")

mod:registerAssetId("models/BerryFarm.fbx/Prefab/HatPart01", "PREFAB_HAT_BERRYPICKER1")
mod:registerAssetId("models/BerryFarm.fbx/Prefab/HatPart02", "PREFAB_HAT_BERRYPICKER2")

mod:registerAssetId("models/BerryFarm.fbx/Materials/Material.BushRed", "REDBERRIES")
mod:registerAssetId("models/BerryFarm.fbx/Materials/Material.BushBlue", "BLUEBERRIES")

mod:registerAssetId("models/BerryFarm.fbx/Materials/Material.Wicker", "WICKER")

mod:registerEnumValue("BUILDING_PART_TYPE", "BERRYBUSHRED")
mod:registerEnumValue("ATTACH_NODE_TYPE", "BERRYBUSHRED")

mod:registerEnumValue("BUILDING_PART_TYPE", "BERRYBUSHBLUE")
mod:registerEnumValue("ATTACH_NODE_TYPE", "BERRYBUSHBLUE")

mod:registerPrefabComponent("models/BerryFarm.fbx/Prefab/BerryBushRedPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "BERRYBUSHRED"
})

mod:registerPrefabComponent("models/BerryFarm.fbx/Prefab/BerryBushBluePart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "BERRYBUSHBLUE"
})

mod:override({
    Id = "REDBERRIES",
	HasAlphaTest = true,
	BackFaceVisible = true
})

mod:override({
    Id = "BLUEBERRIES",
	HasAlphaTest = true,
	BackFaceVisible = true
})

mod:registerAssetId("models/BerryFarm.fbx/Materials/Material.RoofThatch", "THATCH_ROOF")
mod:override({
    Id = "THATCH_ROOF",
	BackFaceVisible = true,
	HasAlphaTest = true
})

mod:override({
    Id = "WICKER",
	HasAlphaTest = true,
	BackFaceVisible = true
})



-- Attach nodes -------------------------------------------------------------------------------------
for i = 1, 1, 1 do
    mod:registerPrefabComponent("models/BerryFarm.fbx/Prefab/BerryHutPart01/attach/Attach_Bush." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_ATTACH_NODE", AttachNodeTypeList = { "BERRYBUSHRED" } })
end



-- Grounding
for i=1, 16, 1 do
	mod:registerPrefabComponent("models/BerryFarm.fbx/Prefab/BerryHutPart01/attach/Attach_Bush." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Monument: Berry Huts
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_BLUEBERRIES",
	Name = "BUILDING_BLUEBERRIES_NAME",
	Description = "BUILDING_BLUEBERRIES_DESC",
	BuildingType = "FOOD_PRODUCTION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	IsEditable = true,
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_BLUEBERRIES",
			BuildingPartList = { 
				"BUILDING_PART_BERRYHUT01",
			}
		},		
    }
})



-- Building Function: Berry Hut 01 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_BLUEBERRIES_BERRYHUT01",
    Name = "BUILDING_FUNCTION_BLUEBERRIES_BERRYHUT01_NAME",
    WorkerCapacity = 3,
    RelatedJob = { 
        Job = "BERRY_PICKER", --"GATHERER", 
        Behavior = "BEHAVIOR_PRODUCE_TREE_COLLECTOR" --"BEHAVIOR_GATHER"
	},--[[
	InputInventoryCapacity = {
		{ Resource = "BERRIES", Quantity = 1 },
	},]]--
    ResourceListNeeded = {
		{ Resource = "BERRIES", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "BERRIES", Quantity = 1 },
	}
})

mod:register({
	DataType = "JOB",
	Id = "BERRY_PICKER",
	JobName = "BERRY_PICKER_NAME",
	JobDescription = "BERRY_PICKER_DESC",
	IsLockedByDefault = false,
    ProductionDelay = 5, -- set this as you wish for balancing
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        WalkAnimation = "WALKING",
		IdleAnimation = "GATHER",
		FemaleHatList = {
            "PREFAB_HAT_BERRYPICKER1",
        }, 
        MaleHatList = {
            "PREFAB_HAT_BERRYPICKER2",
        }
	}
})



-- Resource Container: Red Berries -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/BerryFarm.fbx/Prefab/BerryBushRedPart", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",
    IsReplenishable = true,
    ReplenishDurationInDays = 7,
    ReplenishQuantity = 2,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 2, -- maximum container stock
    Radius = 1.2, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
})



-- Resource Container: Blue Berries -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/BerryFarm.fbx/Prefab/BerryBushBluePart", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",
    IsReplenishable = true,
    ReplenishDurationInDays = 7,
    ReplenishQuantity = 2,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 2, -- maximum container stock
    Radius = 1.2, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
})



-- Building Part: Individual Red Bushes -------------------------------------------------------------------------------------
for i=1, 1, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_BERRYBUSHRED_" .. string.sub("000" .. i, -3),
        Name = "BUILDING_PART_BERRYBUSHRED_" .. string.sub("000" .. i, -3) .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_BERRYBUSHRED_" .. string.sub("000" .. i, -3)
        }
    })

end



-- Building Part: Individual Blue Bushes -------------------------------------------------------------------------------------
for i=1, 1, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_BERRYBUSHBLUE_" .. string.sub("000" .. i, -3),
        Name = "BUILDING_PART_BERRYBUSHBLUE_" .. string.sub("000" .. i, -3) .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_BERRYBUSHBLUE_" .. string.sub("000" .. i, -3)
        }
    })

end



-- Building Part: Berry Farm 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BERRYHUT01_PART_ASSEMBLAGE",
	Name = "BERRYHUT01_PART_ASSEMBLAGE_NAME", 
	-- Category = "CORE", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_BERRYHUT01" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_BERRYBUSHBLUE_001", OptionalAttachNodeString = "Attach_Bush.001" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.002" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.003" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.004" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHBLUE_001", OptionalAttachNodeString = "Attach_Bush.005" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHBLUE_001", OptionalAttachNodeString = "Attach_Bush.006" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.007" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHBLUE_001", OptionalAttachNodeString = "Attach_Bush.008" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHBLUE_001", OptionalAttachNodeString = "Attach_Bush.009" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.010" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.011" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.012" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.013" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.014" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHRED_001", OptionalAttachNodeString = "Attach_Bush.015" },
			{ BuildingPart = "BUILDING_PART_BERRYBUSHBLUE_001", OptionalAttachNodeString = "Attach_Bush.016" },
		}
	},
})



mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_BERRYHUT01",
	Name = "BUILDING_PART_BERRYHUT01_NAME", 
    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BERRYHUT01_PART_ASSEMBLAGE"
        },
        -- MiniatureConfig = {
            -- ClipUnderGround = true,
            -- GroupHeight = 4,
            -- CameraPosition = { 0, 8, -30 },
            -- OrientationOffset = 0,
            -- CameraPitchOffset = 0.0
        -- },
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_BLUEBERRIES_BERRYHUT01",
	ConstructionVisual = "PREFAB_CONSTR_BUILDING_PART_BERRYHUT01",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5.0, 6.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		},
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 20 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
		}
    }
})



-- Construction Visual
-----------------------------------------------------------------------------------
mod:registerAssetId("models/BerryFarm.fbx/Prefab/ConstructionVisual", "PREFAB_CONSTR_BUILDING_PART_BERRYHUT01")



-- Grounding
-----------------------------------------------------------------------------------
mod:registerPrefabComponent("models/BerryFarm.fbx/Prefab/BerryHutPart01/BoxSmallBerries.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BerryFarm.fbx/Prefab/BerryHutPart01/pack", {DataType = "COMP_GROUNDED"})


